package com.example.orcs.and.tactics;


import java.util.ArrayList;

import org.andengine.entity.sprite.Sprite;
import org.andengine.opengl.texture.region.ITextureRegion;
import org.andengine.opengl.vbo.VertexBufferObjectManager;



public class Player extends Sprite {
	
	private int HitPoints;
	private int MaxHitPoints;
	private int Range;
	private int Movement;
	private int minDamage;
	private int maxDamage;
	private int Armor;
	private int Attack;
	private int Speed;
	
	private String Name;
	private SpritePoint playerSpritePoint;
	ArrayList<Ability> playerAbilities;
	
	public Player(float pX, float pY, ITextureRegion pTextureRegion,
			VertexBufferObjectManager pVertexBufferObjectManager,
			int maxhitPoints, int range, int movement, int minDamage,
			int maxDamage, int armor, int attack, int speed, String name) {
		super(pX, pY, pTextureRegion, pVertexBufferObjectManager);
		MaxHitPoints = maxhitPoints;
		Range = range;
		Movement = movement;
		this.minDamage = minDamage;
		this.maxDamage = maxDamage;
		Armor = armor;
		Attack = attack;
		Speed = speed;
		Name = name;
		playerSpritePoint = new SpritePoint();
	}

	public Player(float pX, float pY, ITextureRegion pTextureRegion,
			VertexBufferObjectManager pVertexBufferObjectManager,
			int hitPoints, int maxHitPoints, int range, int movement,
			int minDamage, int maxDamage, int armor, int attack, int speed,
			String name, ArrayList<Ability> playerAbilities) {
		super(pX, pY, pTextureRegion, pVertexBufferObjectManager);
		HitPoints = hitPoints;
		MaxHitPoints = maxHitPoints;
		Range = range;
		Movement = movement;
		this.minDamage = minDamage;
		this.maxDamage = maxDamage;
		Armor = armor;
		Attack = attack;
		Speed = speed;
		Name = name;
		this.playerAbilities = playerAbilities;
	}


	public SpritePoint getSpritePoint(){
		playerSpritePoint.setSpritePoint(super.getX(), super.getY());
		return playerSpritePoint;
	}
	
	public String getName(){
		return Name;
	}

	public void setName(String name){
		Name = name;
	}

	public float getX(){
		return super.getX();
	}

	public float getY(){
		return super.getY();
	}
	
	public int getHitPoints() {
		return HitPoints;
	}
	
	public void setHitPoints(int hitPoints) {
		HitPoints = hitPoints;
	}
	
	public int getMaxHitPoints() {
		return MaxHitPoints;
	}
	
	public void setMaxHitPoints(int maxhitPoints) {
		MaxHitPoints = maxhitPoints;
	}

	public int getRange() {
		if(playerAbilities!=null){
			for(Ability a:playerAbilities){
				if(a.getIsActive() && a instanceof ActiveAbility){
					return Range + ((ActiveAbility)a).getBonusRange();
				}
			}
		}
		return Range;
	}

	public void setRange(int range) {
		Range = range;
	}

	public int getMovement() {
		return Movement;
	}

	public void setMovement(int movement) {
		Movement = movement;
	}

	public int getMinDamage() {
		if(playerAbilities!=null){
			for(Ability a:playerAbilities){
				if(a.getIsActive()){
					return minDamage + a.getMaxDamageBonus();
				}
			}
		}
		return minDamage;
	}

	public void setMinDamage(int minDamage) {
		this.minDamage = minDamage;
	}

	public int getMaxDamage() {
		if(playerAbilities!=null){
			for(Ability a:playerAbilities){
				if(a.getIsActive()){
					return maxDamage + a.getMaxDamageBonus();
				}
			}
		}
		return maxDamage;
	}

	public void setMaxDamage(int maxDamage) {
		this.maxDamage = maxDamage;
	}

	public int getArmor() {
		if(playerAbilities!=null){
			for(Ability a:playerAbilities){
				if(a.getIsActive()){
					return Armor + a.getBonusArmor();
				}
			}
		}
		return Armor;
	}

	public void setArmor(int armor) {
		Armor = armor;
	}

	public int getAttack() {
		if(playerAbilities!=null){
			for(Ability a:playerAbilities){
				if(a.getIsActive()){
					return Attack + a.getBonusAttack();
				}
			}
		}
		return Attack;
	}

	public void setAttack(int attack) {
		Attack = attack;
	}

	public int getSpeed() {
		return Speed;
	}

	public void setSpeed(int speed) {
		Speed = speed;
	}

	public ArrayList<Ability> getPlayerAbilities() {
		return playerAbilities;
	}
	
	public void setPlayerAbilities(ArrayList<Ability> playerAbilities) {
		this.playerAbilities = playerAbilities;
	}

	public void readyAbilities() {
		// TODO Auto-generated method stub
		
	}
	
}
